SystemOrganization addCategory: #TusLibros!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

TusLibrosTest class
	instanceVariableNames: 'products'!

TusLibrosTest class
	instanceVariableNames: 'products'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 21:00'!
aBook
	^1! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:42'!
aBookWithISBN: isbn  
	^isbn! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 18:27'!
aCartWithCatalog: aCatalog  
	^Cart with: aCatalog! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/8/2013 18:15'!
aCashier
	^Cashier withSalesBook: self anEmptySalesBook andMerchantProcessor: self aSuccessMerchantProcessor.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:22'!
aCatalog
	^Catalog new! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 20:47'!
aCatalogWithProduct: aProduct 
	| catalog |
	
	catalog := Catalog new.
	catalog add: aProduct withPrice: 1.
	
	^catalog! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/8/2013 19:25'!
aCreditCard
	^CreditCard with: (self currentMonth ) and:  1and: 1.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/8/2013 19:26'!
aCreditCardExpired
	^CreditCard with: (self currentMonth previous) and:  1and: 1.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/8/2013 18:04'!
aMerchantProcessor

	^ PluggableStubMerchantProcessor new.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/8/2013 20:00'!
aMerchantProcessorForStolenCard
	
	| aMerchantProcessor |
	
	aMerchantProcessor := PluggableStubMerchantProcessor new.
	aMerchantProcessor paymentClosure: '1|The card has been stolen'.
	^ aMerchantProcessor.
! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/8/2013 20:00'!
aSuccessMerchantProcessor
	
	| aMerchantProcessor |
	
	aMerchantProcessor := PluggableStubMerchantProcessor new.
	aMerchantProcessor paymentClosure: '0|OK' .
	^ aMerchantProcessor.
	
	! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:34'!
anEmptyCart
	^	Cart with: (self aCatalog)! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:23'!
anEmptyCatalog
	^Catalog new! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 18:16'!
anEmptySalesBook
	^OrderedCollection new! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/8/2013 19:22'!
currentMonth
^Month month: 2  year: 2000.! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'FacundoPippia 6/3/2013 18:22'!
testAddProductShouldFailIfProductIsNotInCatalog
	| cart |
	
	cart := self aCartWithCatalog: self anEmptyCatalog.
	
	self should: [cart add: self aBook] 
		raise: Error 
		withExceptionDo: [ :anError |
			self assert: anError messageText = 'Product is not in catalog'.
			self assert: cart isEmpty ]! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'FacundoPippia 5/29/2013 20:18'!
testCartShouldBeEmptyAfterCreation

	self assert: self anEmptyCart isEmpty

 ! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'FacundoPippia 6/3/2013 18:22'!
testCartShouldContainAProductThatWasAdded

	| aCart book|
	book := self aBook.
	aCart := self aCartWithCatalog: (Set with: book).
	aCart add: book.

	self assert: (aCart contains: book).! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'FacundoPippia 6/3/2013 18:22'!
testCartShouldContainTheAmountOfBooksAdded
	"comment stating purpose of message"

	| cart book anotherBook catalog|
	book := self aBook.
	anotherBook := self aBook.
	catalog := (Set with: book with: anotherBook).
	cart := self aCartWithCatalog: catalog.
	cart add: book.
	cart add: anotherBook.
	self assert: (cart productCount = 2).! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'FacundoPippia 6/3/2013 18:22'!
testCartShouldNotBeEmptyAfterAddingABook
	"comment stating purpose of message"
	|cart book catalog|
	book := self aBook.
	catalog := (Set with: book).
	cart := self aCartWithCatalog: (catalog).
	cart add: book.
	self deny: (cart isEmpty).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/8/2013 18:56'!
testCashierShouldntCheckoutTheCartWhenTheCardHasBeenStolen
	| book cart salesBook cashier sale |
	
	book := self aBook.
	
	cart := self aCartWithCatalog: (self aCatalogWithProduct: book).
	cart add: book.
	
	salesBook := self anEmptySalesBook.
	
	cashier := Cashier withSalesBook: salesBook andMerchantProcessor: self aMerchantProcessorForStolenCard.

	self should: [ sale := cashier checkout: cart using: self aCreditCard at: self today] 
		raise: Error 
		withExceptionDo: [ :anError | 
			self assert: salesBook isEmpty.
			self assert: anError messageText = Cashier stolenCardErrorMessage.
		].
	
	self deny: (salesBook includes: sale).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/8/2013 20:15'!
testCashierShouldntCheckoutTheCartWhenTheCardHasExpired
	| cart book catalog sale salesBook cashier |
	
	
	book := self aBookWithISBN: 1.
	catalog := self anEmptyCatalog.
	catalog add: book withPrice: 4.

	salesBook := self anEmptySalesBook.
	
	cashier := Cashier withSalesBook: salesBook andMerchantProcessor: self aMerchantProcessorForStolenCard.
		
	cart := self aCartWithCatalog: catalog.
	cart add: book.
	cart add: book.
	
	self should: [sale := self aCashier checkout: cart using: self aCreditCardExpired at: self currentMonth.] 
		raise: Error 
		withExceptionDo: [ :anError |
			self assert: anError messageText = Cashier expiredCardCheckoutErrorMessage. ].
		
	self deny: (salesBook includes: sale).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/9/2013 18:39'!
testCashierShouldntTalkWithMerchantProcessorWhenTheCardHasExpired

	| cart book catalog sale salesBook cashier merchantProcessor |
	
	
	book := self aBookWithISBN: 1.
	catalog := self anEmptyCatalog.
	catalog add: book withPrice: 4.

	salesBook := self anEmptySalesBook.
	
	merchantProcessor:= PluggableStubMerchantProcessor new.
	
	cashier := Cashier withSalesBook: salesBook andMerchantProcessor: merchantProcessor.
		
	cart := self aCartWithCatalog: catalog.
	cart add: book.
	cart add: book.
	
	self should: [sale := self aCashier checkout: cart using: self aCreditCardExpired at: self currentMonth.] 
		raise: Error 
		withExceptionDo: [ :anError |
			self assert: anError messageText = Cashier expiredCardCheckoutErrorMessage. ].
		
	self deny: (merchantProcessor called).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/5/2013 21:20'!
testCheckoutShouldFailIfCartIsEmpty
	| cart cashier salesBook creditCard |
	
	cashier := self aCashier.
	cart := self anEmptyCart.
	salesBook := self anEmptySalesBook.
	creditCard := self aCreditCard.
	
	self should: [ cashier checkout: cart using: creditCard at: self today] 
		raise: Error 
		withExceptionDo: [ :anError | 
			self assert: salesBook isEmpty.
			self assert: anError messageText = Cashier emptyCartCheckoutErrorMessage.
		]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/5/2013 21:24'!
testSaleContainsTheSameProductsThanTheCart
	| cart book anotherBook catalog sale aBag|
	
	book := self aBookWithISBN: 1.
	anotherBook := self aBookWithISBN: 2.
	catalog := self anEmptyCatalog.
	catalog add: book withPrice: 4.
	catalog add: anotherBook withPrice: 5.
	
	cart := self aCartWithCatalog: catalog.
	cart add: book.
	cart add: anotherBook.


	sale := self aCashier checkout: cart using: self aCreditCard  at: self today. 
	
	aBag := Bag new.
	sale priceDetail do: [ :saleItem | aBag add: saleItem product ].
	
	self assert: aBag = cart products.
	! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'FacundoPippia 6/8/2013 18:40'!
testSaleIsCreatedWhenCartIsNotEmpty
	| book cart salesBook cashier sale |
	
	book := self aBook.
	
	cart := self aCartWithCatalog: (self aCatalogWithProduct: book).
	cart add: book.
	
	salesBook := self anEmptySalesBook.
	
	cashier := Cashier withSalesBook: salesBook andMerchantProcessor: self aSuccessMerchantProcessor.

	sale := cashier checkout: cart using: self aCreditCard at: self today.
	
	self assert: (salesBook includes: sale).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/5/2013 21:25'!
testSaleTotalIsSumOfCartProductsPrices
	| cart book anotherBook catalog sale |
	
	book := self aBookWithISBN: 1.
	anotherBook := self aBookWithISBN: 2.
	catalog := self anEmptyCatalog.
	catalog add: book withPrice: 4.
	catalog add: anotherBook withPrice: 5.
	
	cart := self aCartWithCatalog: catalog.
	cart add: book.
	cart add: anotherBook.


	sale := self aCashier checkout: cart using: self aCreditCard at: self today.

	self assert: (sale total = 9).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/5/2013 21:25'!
testSaleTotalShouldBeSumOfCartProductPricesWhenThereAreRepeatedProducts
	| cart book catalog sale |
	
	book := self aBookWithISBN: 1.
	catalog := self anEmptyCatalog.
	catalog add: book withPrice: 4.

	cart := self aCartWithCatalog: catalog.
	cart add: book.
	cart add: book.
	
	sale := self aCashier checkout: cart using: self aCreditCard at: self today.
	
	self assert: (sale total = 8).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/8/2013 19:22'!
today
^Month month: 2  year: 2000.! !

Object subclass: #Cart
	instanceVariableNames: 'products catalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:31'!
with: aCatalog
	^self new initializeWith: aCatalog ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:55'!
add: aProduct 
	(catalog includes: aProduct) ifFalse: [ Error signal: 'Product is not in catalog' ].
	products add: aProduct.
	
! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 21:09'!
contains: aProduct
	^ products includes: aProduct.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:21'!
initialize
	products := Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:25'!
initializeWith: aCatalog 
	products := Bag new.
	catalog := aCatalog! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:21'!
isEmpty
	^ products isEmpty.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:55'!
priceOf: aProduct  
	^catalog priceOf: aProduct.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/29/2013 20:30'!
productCount
	^ products size.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 19:02'!
products
 ^products.! !

Object subclass: #Cashier
	instanceVariableNames: 'salesBook merchantProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 17:54'!
emptyCartCheckoutErrorMessage
	^ 'Cart is empty'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/5/2013 20:32'!
expiredCardCheckoutErrorMessage
	^ 'The card has expired'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/8/2013 18:57'!
stolenCardErrorMessage
	^ 'The card has been stolen'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/8/2013 18:12'!
withSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.
	^self new initializeWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/8/2013 20:01'!
checkout: aCart using: aCreditCard at: aDate
	| sale paymentResult |
	
	
	(aCart isEmpty) ifTrue: [ Error signal: (self class emptyCartCheckoutErrorMessage) ].
	
	(aCreditCard isExpiredAtDate: aDate) ifTrue: [ Error signal: (self class expiredCardCheckoutErrorMessage ) ].
	
	sale := Sale new.
	aCart products do: [ :aProduct | sale addProduct: aProduct withPrice: (aCart priceOf: aProduct) ].
	paymentResult := merchantProcessor payWith: aCreditCard aTotalOf: (sale total). 

"	(paymentResult value = '0|OK') ifFalse: [  Error signal: (self class stolenCardErrorMessage) ]."
	(paymentResult value = '0|OK') ifFalse: [  Error signal: (((paymentResult asString subStrings: '|') at: 2)) ].
"	(paymentResult value = '0|OK') ifFalse: [  Error signal: paymentResult ]."

	salesBook add: sale.  
	^ sale.


	
! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 18:18'!
initializeWithSalesBook: aSalesBook 
	salesBook := aSalesBook.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/8/2013 18:13'!
initializeWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor
	salesBook := aSalesBook.
	merchantProcessor := aMerchantProcessor.! !

Object subclass: #Catalog
	instanceVariableNames: 'productsPrices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Catalog methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:25'!
add: aProduct withPrice: aPrice  
	productsPrices at: aProduct put: aPrice ! !

!Catalog methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:30'!
includes: aProduct  
	^productsPrices includesKey: aProduct ! !

!Catalog methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:25'!
initialize
	productsPrices := Dictionary new.! !

!Catalog methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 20:42'!
priceOf: aProduct  
	^(productsPrices at: aProduct).! !

Object subclass: #CreditCard
	instanceVariableNames: 'expirationDate owner number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CreditCard class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 22:11'!
with: anExpirationDate and: aNumber and: anOwner
	^ self new initializeWith: anExpirationDate and: aNumber and: anOwner.! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 22:20'!
initializeWith: anExpirationDate and: aNumber and: anOwner 
	expirationDate := anExpirationDate.
	number := aNumber.
	owner := anOwner.! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/5/2013 20:36'!
isExpiredAtDate: aDate
	^	expirationDate < aDate.! !

Object subclass: #PluggableStubMerchantProcessor
	instanceVariableNames: 'paymentClosure called'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!PluggableStubMerchantProcessor methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/9/2013 18:37'!
called
^called.! !

!PluggableStubMerchantProcessor methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/9/2013 18:36'!
initialize 
called:= false.! !

!PluggableStubMerchantProcessor methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/9/2013 18:37'!
payWith: aCreditCardNumber aTotalOf: anAMount.
	called:=true.
	^ paymentClosure.! !

!PluggableStubMerchantProcessor methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/9/2013 18:37'!
paymentClosure: aBlockClosure 
		called:=true.
	paymentClosure := aBlockClosure! !

Object subclass: #Sale
	instanceVariableNames: 'priceDetail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Sale class
	instanceVariableNames: 'products'!

Sale class
	instanceVariableNames: 'products'!

!Sale class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 20:46'!
total
	
	products do: [  ] ! !

!Sale class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/3/2013 19:06'!
withProducts: aProducts 
	products:= aProducts! !

!Sale methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 21:19'!
addProduct: aProduct withPrice: price  
	priceDetail add: (SaleItem with: aProduct and: price).! !

!Sale methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 20:22'!
initialize
	priceDetail := Bag new.! !

!Sale methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 21:41'!
priceDetail
	^ priceDetail! !

!Sale methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 20:39'!
total
	| sumTotal |
	sumTotal := 0.
	priceDetail do: [ :saleItem | sumTotal := sumTotal + saleItem price ].
	
	^sumTotal! !

Object subclass: #SaleItem
	instanceVariableNames: 'product price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

SaleItem class
	instanceVariableNames: 'product price'!

SaleItem class
	instanceVariableNames: 'product price'!

!SaleItem class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 21:21'!
with: aProduct and: aPrice
	^ self new initializeWith: aProduct and: aPrice.! !

!SaleItem methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 21:17'!
initializeWith: aProduct and: aPrice
	product := aProduct.
	price := aPrice.! !

!SaleItem methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 21:22'!
price
	^ price! !

!SaleItem methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/4/2013 21:37'!
product
	^ product.! !
